/**
 * Uppgift 5: InchModel
 * 
 * @author Uno Holmer
 * @version 2015-10-20
 */
public class InchModel {
    private int a,b;
// a
    public InchModel(int a,int b) {
        if ( a < 0 || b <= 0 )
            throw new NumberFormatException("InchModel: Illegal fraction");
        if ( ! isPrecision(b) )       
            throw new NumberFormatException("InchModel: Illegal fraction: "
                                            + b);
        this.a = a;
        this.b = b;
        normalize();
    }
// b
    public InchModel(double d,int precision) {
        if ( ! isPrecision(precision) )               
            throw new NumberFormatException("InchModel: Illegal fraction: "
                                            + precision);        
        double inch = d/25.4;
        int intPart = (int)Math.floor(inch);
        int fracPart = Math.round((float)(precision*(inch-intPart)));
        a = precision*intPart+fracPart;
        b = precision;
        normalize();
    }
    // Ex. 4.7244 inch och precision 16 ger 16*4+12 = 76/16
    // vilket förkortas till 19/4 inch.
    
//     // Detta går inte eftersom klassen saknar kopieringskonstruktor.
//     public InchModel(String s) {
//         this(parse(s));
//     }
    
// c
    public static InchModel parse(String s) {
        String[] buf = s.split("/");
        int a = Integer.parseInt(buf[0]);
        if ( buf.length == 1 )
            return new InchModel(a,1);
        else {
            int b = Integer.parseInt(buf[1]);
            return new InchModel(a,b);
        }
    }
    
    private boolean isPrecision(int x) {
        for ( int k = 1; k <= 64; k *= 2 )
            if ( x == k )
                return true;
        return false;
    }
    
    // Euklides algoritm
    private int gcd(int a,int b) {
        if ( b == 0 )
            return a;
        else 
            return gcd(b,a % b);
    }
    
    private void normalize() {
        int gcd = gcd(a,b);
        a /= gcd;
        b /= gcd;
    }
    
    public double toMetric() {
        return (double)a/(double)b*25.4;
    }
// d
    public boolean equals(Object obj) {
        if ( obj == this )
            return true;
        else if ( obj instanceof InchModel ) {
            InchModel o = (InchModel)obj;
            return a == o.a && b == o.b;
        } else
            return false;	
    }
// e
    public String toString() {
        if ( toMetric() < 0.00000001 )
            return "0";
        else
            return "" + a/b + " " + a % b + "/" + b;
    }
}	














